<?php
$los_option_api_key = get_option( 'los_api_key' );
$los_option_template = get_option( 'los_template' );
?>

<div class="wrap">

	<h2><?php _e( 'Settings' ); ?> › Live.Online Statistics</h2>

	<form method="post" action="options.php">

		<?php settings_fields( 'los_general_options' ); ?>
		<?php do_settings_sections( 'los_general_options' ); ?>

		<table class="form-table">

			<tr valign="top">

				<th scope="row"><label for="los_api_key"><?php _e( 'API Key', 'hockeydata_los' ); ?></label></th>

				<td>

					<input type="text" name="los_api_key" id="los_api_key" value="<?php echo esc_attr( $los_option_api_key ); ?>" class="regular-text" onchange="losCheckApiKey();">

					<span id="hd-los-api-key-checking"><?php _e( 'Checking...', 'hockeydata_los' ); ?></span>

					<span id="hd-los-api-key-ok" class="hd-los-ok"><?php _e( '[OK]', 'hockeydata_los' ); ?></span>

					<span id="hd-los-api-key-nok" class="hd-los-nok"><?php _e( '[INVALID]', 'hockeydata_los' ); ?></span>

				</td>

			</tr>

			<tr valign="top">

				<th scope="row"><label for="los_template"><?php _e( 'Template', 'hockeydata_los' ); ?></label></th>

				<td>

					<select name="los_template" id="los_template" class="regular-text">

						<option value=""<?php if ( ! $los_option_template ) { ?> selected="selected"<?php } ?>><?php _e( '[None]', 'hockeydata_los' ); ?></option>

						<option value="default"<?php if ( $los_option_template == 'default' ) { ?> selected="selected"<?php } ?>><?php _e( 'Default', 'hockeydata_los' ); ?></option>

						<option value="dark"<?php if ( $los_option_template == 'dark' ) { ?> selected="selected"<?php } ?>><?php _e( 'Dark', 'hockeydata_los' ); ?></option>

						<option value="glass"<?php if ( $los_option_template == 'glass' ) { ?> selected="selected"<?php } ?>><?php _e( 'Glass', 'hockeydata_los' ); ?></option>

					</select>

				</td>

			</tr>

		</table>

		<?php submit_button(); ?>

	</form>

</div>

<script>

	jQuery( function() {

		losCheckApiKey();

	} );

</script>